com.fasterxml.jackson.databind.node

## Class ArrayNode

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializable.Base
  - - com.fasterxml.jackson.databind.JsonNode
    - - com.fasterxml.jackson.databind.node.BaseJsonNode
      - - com.fasterxml.jackson.databind.node.ContainerNode<ArrayNode>
        - - com.fasterxml.jackson.databind.node.ArrayNode

All Implemented Interfaces:
  TreeNode, JsonSerializable, JsonNodeCreator, Serializable, Iterable<JsonNode>

    public class ArrayNode
    extends ContainerNode<ArrayNode>
    implements Serializable

Node class that represents Arrays mapped from JSON content.

Note: class was `final` temporarily for Jackson 2.2.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonNode

`JsonNode.OverwriteMode`

### Nested classes/interfaces inherited from interface com.fasterxml.jackson.databind.JsonSerializable

`JsonSerializable.Base`

### Field Summary

### Fields inherited from class com.fasterxml.jackson.databind.node.ContainerNode

`_nodeFactory`

### Constructor Summary

Constructors
Constructor and Description
`ArrayNode(JsonNodeFactory nf)`
`ArrayNode(JsonNodeFactory nf, int capacity)`
`ArrayNode(JsonNodeFactory nf, List<JsonNode> children)`

### Method Summary

All Methods Instance Methods Concrete Methods Deprecated Methods
`protected ArrayNode` `_add(JsonNode node)`
`protected JsonNode` `_at(JsonPointer ptr)` Helper method used by other methods for traversing the next step of given path expression, and returning matching value node if any: if no match, `null` is returned.
`protected boolean` `_childrenEqual(ArrayNode other)`
`protected ArrayNode` `_insert(int index, JsonNode node)`
`protected ArrayNode` `_set(int index, JsonNode node)`
`protected ArrayNode` `_withArray(JsonPointer origPtr, JsonPointer currentPtr, JsonNode.OverwriteMode overwriteMode, boolean preferIndex)`
`protected ArrayNode` `_withArrayAddTailElement(JsonPointer tail, boolean preferIndex)`
`protected ObjectNode` `_withObject(JsonPointer origPtr, JsonPointer currentPtr, JsonNode.OverwriteMode overwriteMode, boolean preferIndex)`
`protected ObjectNode` `_withObjectAddTailElement(JsonPointer tail, boolean preferIndex)`
`protected void` `_withXxxSetArrayElement(int index, JsonNode value)`
`ArrayNode` `add(BigDecimal v)` Method for adding specified number at the end of this array.
`ArrayNode` `add(BigInteger v)` Method for adding specified number at the end of this array.
`ArrayNode` `add(boolean v)` Method for adding specified boolean value at the end of this array.
`ArrayNode` `add(Boolean v)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `add(byte[] v)` Method for adding specified binary value at the end of this array (note: when serializing as JSON, will be output Base64 encoded)
`ArrayNode` `add(double v)` Method for adding specified number at the end of this array.
`ArrayNode` `add(Double v)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `add(float v)` Method for adding specified number at the end of this array.
`ArrayNode` `add(Float v)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `add(int v)` Method for adding specified number at the end of this array.
`ArrayNode` `add(Integer v)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `add(JsonNode value)` Method for adding specified node at the end of this array.
`ArrayNode` `add(long v)` Method for adding specified number at the end of this array.
`ArrayNode` `add(Long v)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `add(short v)` Method for adding specified number at the end of this array.
`ArrayNode` `add(Short v)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `add(String v)` Method for adding specified String value at the end of this array.
`ArrayNode` `addAll(ArrayNode other)` Method for adding all child nodes of given Array, appending to child nodes this array contains
`ArrayNode` `addAll(Collection<? extends JsonNode> nodes)` Method for adding given nodes as child nodes of this array node.
`ArrayNode` `addArray()` Method that will construct an ArrayNode and add it at the end of this array node.
`ArrayNode` `addNull()` Method that will add a null value at the end of this array node.
`ObjectNode` `addObject()` Method that will construct an ObjectNode and add it at the end of this array node.
`ArrayNode` `addPOJO(Object pojo)` Method that will construct a POJONode and add it at the end of this array node.
`ArrayNode` `addRawValue(RawValue raw)`
`JsonToken` `asToken()` Method that can be used for efficient type detection when using stream abstraction for traversing nodes.
`ArrayNode` `deepCopy()` Method that can be called to get a node that is guaranteed not to allow changing of this node through mutators on this node or any of its children.
`Iterator<JsonNode>` `elements()` Method for accessing all value nodes of this Node, iff this node is a JSON Array or Object node.
`boolean` `equals(Comparator<JsonNode> comparator, JsonNode o)` Entry method for invoking customizable comparison, using passed-in `Comparator` object.
`boolean` `equals(Object o)` Equality for node objects is defined as full (deep) value equality.
`ObjectNode` `findParent(String fieldName)` Method for finding a JSON Object that contains specified field, within this node or its descendants.
`List<JsonNode>` `findParents(String fieldName, List<JsonNode> foundSoFar)`
`JsonNode` `findValue(String fieldName)` Method for finding a JSON Object field with specified name in this node or its child nodes, and returning value it has.
`List<JsonNode>` `findValues(String fieldName, List<JsonNode> foundSoFar)`
`List<String>` `findValuesAsText(String fieldName, List<String> foundSoFar)`
`JsonNode` `get(int index)` Method for accessing value of the specified element of an array node.
`JsonNode` `get(String fieldName)` Method for accessing value of the specified field of an object node.
`JsonNodeType` `getNodeType()` Return the type of this node
`int` `hashCode()`
`ArrayNode` `insert(int index, BigDecimal v)` Method that will insert specified numeric value at specified position in this array.
`ArrayNode` `insert(int index, BigInteger v)` Method that will insert specified numeric value at specified position in this array.
`ArrayNode` `insert(int index, boolean v)` Method that will insert specified String at specified position in this array.
`ArrayNode` `insert(int index, Boolean value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `insert(int index, byte[] v)` Method that will insert specified binary value at specified position in this array (note: when written as JSON, will be Base64 encoded)
`ArrayNode` `insert(int index, double v)` Method that will insert specified numeric value at specified position in this array.
`ArrayNode` `insert(int index, Double v)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `insert(int index, float v)` Method that will insert specified numeric value at specified position in this array.
`ArrayNode` `insert(int index, Float v)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `insert(int index, int v)` Method that will insert specified numeric value at specified position in this array.
`ArrayNode` `insert(int index, Integer v)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `insert(int index, JsonNode value)` Method for inserting specified child node as an element of this Array.
`ArrayNode` `insert(int index, long v)` Method that will insert specified numeric value at specified position in this array.
`ArrayNode` `insert(int index, Long v)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `insert(int index, short v)` Method that will insert specified numeric value at specified position in this array.
`ArrayNode` `insert(int index, Short value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `insert(int index, String v)` Method that will insert specified String at specified position in this array.
`ArrayNode` `insertArray(int index)` Method for creating an array node, inserting it at the specified point in the array, and returning the newly created array (note: NOT 'this' array)
`ArrayNode` `insertNull(int index)` Method that will insert a null value at specified position in this array.
`ObjectNode` `insertObject(int index)` Method for creating an `ObjectNode`, appending it at the end of this array, and returning the newly created node (note: NOT 'this' array)
`ArrayNode` `insertPOJO(int index, Object pojo)` Method that will construct a POJONode and insert it at specified position in this array.
`ArrayNode` `insertRawValue(int index, RawValue raw)`
`boolean` `isArray()`
`boolean` `isEmpty()` Convenience method that is functionally same as:
`boolean` `isEmpty(SerializerProvider serializers)` Method that may be called on instance to determine if it is considered "empty" for purposes of serialization filtering or not.
`JsonNode` `path(int index)` This method is similar to `JsonNode.get(int)`, except that instead of returning null if no such element exists (due to index being out of range, or this node not being an array), a "missing node" (node that returns true for `JsonNode.isMissingNode()`) will be returned.
`JsonNode` `path(String fieldName)` This method is similar to `JsonNode.get(String)`, except that instead of returning null if no such value exists (due to this node not being an object, or object not having value for the specified field), a "missing node" (node that returns true for `JsonNode.isMissingNode()`) will be returned.
`JsonNode` `remove(int index)` Method for removing an entry from this ArrayNode.
`ArrayNode` `removeAll()` Method for removing all elements of this array, leaving the array empty.
`JsonNode` `required(int index)` Method is functionally equivalent to `path(index).required()` and can be used to check that this node is an `ArrayNode` (that is, represents JSON Array value) and has value for specified `index` (but note that value may be explicit JSON null value).
`void` `serialize(JsonGenerator g, SerializerProvider provider)` Method called to serialize node instances using given generator.
`void` `serializeWithType(JsonGenerator g, SerializerProvider provider, TypeSerializer typeSer)` Type information is needed, even if JsonNode instances are "plain" JSON, since they may be mixed with other types.
`ArrayNode` `set(int index, BigDecimal v)` Method for setting value of a field to specified numeric value.
`ArrayNode` `set(int index, BigInteger v)` Method for setting value of a field to specified numeric value.
`ArrayNode` `set(int index, boolean v)` Method for setting value of a field to specified String value.
`ArrayNode` `set(int index, Boolean v)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `set(int index, byte[] v)` Method for setting value of a field to specified binary value
`ArrayNode` `set(int index, double v)` Method for setting value of a field to specified numeric value.
`ArrayNode` `set(int index, Double v)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `set(int index, float v)` Method for setting value of a field to specified numeric value.
`ArrayNode` `set(int index, Float v)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `set(int index, int v)`
`ArrayNode` `set(int index, Integer v)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`JsonNode` `set(int index, JsonNode value)` Method that will set specified field, replacing old value, if any.
`ArrayNode` `set(int index, long v)`
`ArrayNode` `set(int index, Long v)`
`ArrayNode` `set(int index, short v)`
`ArrayNode` `set(int index, Short v)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `set(int index, String v)` Method for setting value of a field to specified String value.
`ArrayNode` `setNull(int index)`
`ArrayNode` `setPOJO(int index, Object pojo)`
`ArrayNode` `setRawValue(int index, RawValue raw)`
`int` `size()`
`ObjectNode` `with(String exprOrProperty)` Deprecated.
`ArrayNode` `withArray(String exprOrProperty)` Method that works in one of possible ways, depending on whether `exprOrProperty` is a valid `JsonPointer` expression or not (valid expression is either empty String `""` or starts with leading slash `/` character).

### Methods inherited from class com.fasterxml.jackson.databind.node.ContainerNode

`arrayNode, arrayNode, asText, binaryNode, binaryNode, booleanNode, missingNode, nullNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, objectNode, pojoNode, rawValueNode, textNode`

### Methods inherited from class com.fasterxml.jackson.databind.node.BaseJsonNode

`_jsonPointerIfValid, _reportWrongNodeOperation, _reportWrongNodeType, _withXxxMayReplace, _withXxxVerifyReplace, findPath, numberType, required, toPrettyString, toString, traverse, traverse, withArray, withObject`

### Methods inherited from class com.fasterxml.jackson.databind.JsonNode

`_reportRequiredViolation, _this, asBoolean, asBoolean, asDouble, asDouble, asInt, asInt, asLong, asLong, asText, at, at, bigIntegerValue, binaryValue, booleanValue, canConvertToExactIntegral, canConvertToInt, canConvertToLong, decimalValue, doubleValue, fieldNames, fields, findParents, findValues, findValuesAsText, floatValue, has, has, hasNonNull, hasNonNull, intValue, isBigDecimal, isBigInteger, isBinary, isBoolean, isContainerNode, isDouble, isFloat, isFloatingPointNumber, isInt, isIntegralNumber, isLong, isMissingNode, isNull, isNumber, isObject, isPojo, isShort, isTextual, isValueNode, iterator, longValue, numberValue, properties, require, requiredAt, requiredAt, requireNonNull, shortValue, textValue, withArray, withArray, withObject, withObject, withObject`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.lang.Iterable

`forEach, spliterator`

### Constructor Detail

#### ArrayNode

    public ArrayNode(JsonNodeFactory nf)

#### ArrayNode

    public ArrayNode(JsonNodeFactory nf,
                     int capacity)

Since:
  2.8

#### ArrayNode

    public ArrayNode(JsonNodeFactory nf,
                     List<JsonNode> children)

Since:
  2.7

### Method Detail

#### _at

    protected JsonNode _at(JsonPointer ptr)

Description copied from class: `JsonNode`
Helper method used by other methods for traversing the next step of given path expression, and returning matching value node if any: if no match, `null` is returned.

Specified by:
  `_at` in class `JsonNode`
Parameters:
  `ptr` - Path expression to use
Returns:
  Either matching `JsonNode` for the first step of path or `null` if no match (including case that this node is not a container)

#### deepCopy

    public ArrayNode deepCopy()

Description copied from class: `JsonNode`
Method that can be called to get a node that is guaranteed not to allow changing of this node through mutators on this node or any of its children. This means it can either make a copy of this node (and all mutable children and grand children nodes), or node itself if it is immutable.

Note: return type is guaranteed to have same type as the node method is called on; which is why method is declared with local generic type.

Specified by:
  `deepCopy` in class `JsonNode`
Returns:
  Node that is either a copy of this node (and all non-leaf children); or, for immutable leaf nodes, node itself.

#### with

    @Deprecated
    public ObjectNode with(String exprOrProperty)

Deprecated.
Description copied from class: `JsonNode`
Method that works in one of possible ways, depending on whether `exprOrProperty` is a valid `JsonPointer` expression or not (valid expression is either empty String `""` or starts with leading slash `/` character). If it is, works as a short-cut to:

      withObject(JsonPointer.compile(exprOrProperty));

If it is NOT a valid `JsonPointer` expression, value is taken as a literal Object property name and traversed like a single-segment `JsonPointer`.

NOTE: before Jackson 2.14 behavior was always that of non-expression usage; that is, `exprOrProperty` was always considered as a simple property name.

Overrides:
  `with` in class `JsonNode`

#### withArray

    public ArrayNode withArray(String exprOrProperty)

Description copied from class: `JsonNode`
Method that works in one of possible ways, depending on whether `exprOrProperty` is a valid `JsonPointer` expression or not (valid expression is either empty String `""` or starts with leading slash `/` character). If it is, works as a short-cut to:

      withObject(JsonPointer.compile(exprOrProperty));

If it is NOT a valid `JsonPointer` expression, value is taken as a literal Object property name and traversed like a single-segment `JsonPointer`.

NOTE: before Jackson 2.14 behavior was always that of non-expression usage; that is, `exprOrProperty` was always considered as a simple property name.

Overrides:
  `withArray` in class `JsonNode`
Parameters:
  `exprOrProperty` - Either `JsonPointer` expression for full access (if valid pointer expression), or the name of property for the `ArrayNode`.
Returns:
  `ArrayNode` found or created

#### _withObject

    protected ObjectNode _withObject(JsonPointer origPtr,
                                     JsonPointer currentPtr,
                                     JsonNode.OverwriteMode overwriteMode,
                                     boolean preferIndex)

Specified by:
  `_withObject` in class `ContainerNode<ArrayNode>`

#### _withArray

    protected ArrayNode _withArray(JsonPointer origPtr,
                                   JsonPointer currentPtr,
                                   JsonNode.OverwriteMode overwriteMode,
                                   boolean preferIndex)

Overrides:
  `_withArray` in class `BaseJsonNode`

#### _withObjectAddTailElement

    protected ObjectNode _withObjectAddTailElement(JsonPointer tail,
                                                   boolean preferIndex)

#### _withArrayAddTailElement

    protected ArrayNode _withArrayAddTailElement(JsonPointer tail,
                                                 boolean preferIndex)

#### _withXxxSetArrayElement

    protected void _withXxxSetArrayElement(int index,
                                           JsonNode value)

#### isEmpty

    public boolean isEmpty(SerializerProvider serializers)

Description copied from class: `JsonSerializable.Base`
Method that may be called on instance to determine if it is considered "empty" for purposes of serialization filtering or not.

Overrides:
  `isEmpty` in class `JsonSerializable.Base`

#### getNodeType

    public JsonNodeType getNodeType()

Description copied from class: `JsonNode`
Return the type of this node

Specified by:
  `getNodeType` in class `JsonNode`
Returns:
  the node type as a `JsonNodeType` enum value

#### isArray

    public boolean isArray()

Specified by:
  `isArray` in interface `TreeNode`
Overrides:
  `isArray` in class `JsonNode`

#### asToken

    public JsonToken asToken()

Description copied from class: `BaseJsonNode`
Method that can be used for efficient type detection when using stream abstraction for traversing nodes. Will return the first `JsonToken` that equivalent stream event would produce (for most nodes there is just one token but for structured/container types multiple)

Specified by:
  `asToken` in interface `TreeNode`
Specified by:
  `asToken` in class `ContainerNode<ArrayNode>`

#### size

    public int size()

Specified by:
  `size` in interface `TreeNode`
Specified by:
  `size` in class `ContainerNode<ArrayNode>`

#### isEmpty

    public boolean isEmpty()

Description copied from class: `JsonNode`
Convenience method that is functionally same as:

        size() == 0

for all node types.

Overrides:
  `isEmpty` in class `JsonNode`

#### elements

    public Iterator<JsonNode> elements()

Description copied from class: `JsonNode`
Method for accessing all value nodes of this Node, iff this node is a JSON Array or Object node. In case of Object node, field names (keys) are not included, only values. For other types of nodes, returns empty iterator.

Overrides:
  `elements` in class `JsonNode`

#### get

    public JsonNode get(int index)

Description copied from class: `JsonNode`
Method for accessing value of the specified element of an array node. For other nodes, null is always returned.

For array nodes, index specifies exact location within array and allows for efficient iteration over child elements (underlying storage is guaranteed to be efficiently indexable, i.e. has random-access to elements). If index is less than 0, or equal-or-greater than `node.size()`, null is returned; no exception is thrown for any index.

NOTE: if the element value has been explicitly set as `null` (which is different from removal!), a `NullNode` will be returned, not null.

Specified by:
  `get` in interface `TreeNode`
Specified by:
  `get` in class `ContainerNode<ArrayNode>`
Returns:
  Node that represent value of the specified element, if this node is an array and has specified element. Null otherwise.

#### get

    public JsonNode get(String fieldName)

Description copied from class: `JsonNode`
Method for accessing value of the specified field of an object node. If this node is not an object (or it does not have a value for specified field name), or if there is no field with such name, null is returned.

NOTE: if the property value has been explicitly set as `null` (which is different from removal!), a `NullNode` will be returned, not null.

Specified by:
  `get` in interface `TreeNode`
Specified by:
  `get` in class `ContainerNode<ArrayNode>`
Returns:
  Node that represent value of the specified field, if this node is an object and has value for the specified field. Null otherwise.

#### path

    public JsonNode path(String fieldName)

Description copied from class: `JsonNode`
This method is similar to `JsonNode.get(String)`, except that instead of returning null if no such value exists (due to this node not being an object, or object not having value for the specified field), a "missing node" (node that returns true for `JsonNode.isMissingNode()`) will be returned. This allows for convenient and safe chained access via path calls.

Specified by:
  `path` in interface `TreeNode`
Specified by:
  `path` in class `JsonNode`

#### path

    public JsonNode path(int index)

Description copied from class: `JsonNode`
This method is similar to `JsonNode.get(int)`, except that instead of returning null if no such element exists (due to index being out of range, or this node not being an array), a "missing node" (node that returns true for `JsonNode.isMissingNode()`) will be returned. This allows for convenient and safe chained access via path calls.

Specified by:
  `path` in interface `TreeNode`
Specified by:
  `path` in class `JsonNode`

#### required

    public JsonNode required(int index)

Description copied from class: `JsonNode`
Method is functionally equivalent to `path(index).required()` and can be used to check that this node is an `ArrayNode` (that is, represents JSON Array value) and has value for specified `index` (but note that value may be explicit JSON null value). If this node is Array Node and has value for specified index, value at index is returned; otherwise `IllegalArgumentException` is thrown.

Overrides:
  `required` in class `BaseJsonNode`
Parameters:
  `index` - Index of the value of this Array node to access
Returns:
  Value at specified index of this Array node

#### equals

    public boolean equals(Comparator<JsonNode> comparator,
                          JsonNode o)

Description copied from class: `JsonNode`
Entry method for invoking customizable comparison, using passed-in `Comparator` object. Nodes will handle traversal of structured types (arrays, objects), but defer to comparator for scalar value comparisons. If a "natural" `Comparator` is passed -- one that simply calls `equals()` on one of arguments, passing the other -- implementation is the same as directly calling `equals()` on node.

Default implementation simply delegates to passed in `comparator`, with `this` as the first argument, and `other` as the second argument.

Overrides:
  `equals` in class `JsonNode`
Parameters:
  `comparator` - Object called to compare two scalar `JsonNode` instances, and return either 0 (are equals) or non-zero (not equal)

#### serialize

    public void serialize(JsonGenerator g,
                          SerializerProvider provider)
                   throws IOException

Description copied from class: `BaseJsonNode`
Method called to serialize node instances using given generator.

Specified by:
  `serialize` in interface `JsonSerializable`
Specified by:
  `serialize` in class `BaseJsonNode`
Throws:
  `IOException`

#### serializeWithType

    public void serializeWithType(JsonGenerator g,
                                  SerializerProvider provider,
                                  TypeSerializer typeSer)
                           throws IOException

Description copied from class: `BaseJsonNode`
Type information is needed, even if JsonNode instances are "plain" JSON, since they may be mixed with other types.

Specified by:
  `serializeWithType` in interface `JsonSerializable`
Specified by:
  `serializeWithType` in class `BaseJsonNode`
Throws:
  `IOException`

#### findValue

    public JsonNode findValue(String fieldName)

Description copied from class: `JsonNode`
Method for finding a JSON Object field with specified name in this node or its child nodes, and returning value it has. If no matching field is found in this node or its descendants, returns null.

Specified by:
  `findValue` in class `JsonNode`
Parameters:
  `fieldName` - Name of field to look for
Returns:
  Value of first matching node found, if any; null if none

#### findValues

    public List<JsonNode> findValues(String fieldName,
                                     List<JsonNode> foundSoFar)

Specified by:
  `findValues` in class `JsonNode`

#### findValuesAsText

    public List<String> findValuesAsText(String fieldName,
                                         List<String> foundSoFar)

Specified by:
  `findValuesAsText` in class `JsonNode`

#### findParent

    public ObjectNode findParent(String fieldName)

Description copied from class: `JsonNode`
Method for finding a JSON Object that contains specified field, within this node or its descendants. If no matching field is found in this node or its descendants, returns null.

Specified by:
  `findParent` in class `JsonNode`
Parameters:
  `fieldName` - Name of field to look for
Returns:
  Value of first matching node found, if any; null if none

#### findParents

    public List<JsonNode> findParents(String fieldName,
                                      List<JsonNode> foundSoFar)

Specified by:
  `findParents` in class `JsonNode`

#### set

    public JsonNode set(int index,
                        JsonNode value)

Method that will set specified field, replacing old value, if any.

Parameters:
  `value` - to set field to; if null, will be converted to a `NullNode` first (to remove field entry, call `remove(int)` instead)
Returns:
  Old value of the field, if any; null if there was no old value.

#### add

    public ArrayNode add(JsonNode value)

Method for adding specified node at the end of this array.

Returns:
  This node, to allow chaining

#### addAll

    public ArrayNode addAll(ArrayNode other)

Method for adding all child nodes of given Array, appending to child nodes this array contains

Parameters:
  `other` - Array to add contents from
Returns:
  This node (to allow chaining)

#### addAll

    public ArrayNode addAll(Collection<? extends JsonNode> nodes)

Method for adding given nodes as child nodes of this array node.

Parameters:
  `nodes` - Nodes to add
Returns:
  This node (to allow chaining)

#### insert

    public ArrayNode insert(int index,
                            JsonNode value)

Method for inserting specified child node as an element of this Array. If index is 0 or less, it will be inserted as the first element; if `>= size()`, appended at the end, and otherwise inserted before existing element in specified index. No exceptions are thrown for any index.

Returns:
  This node (to allow chaining)

#### remove

    public JsonNode remove(int index)

Method for removing an entry from this ArrayNode. Will return value of the entry at specified index, if entry existed; null if not.

Returns:
  Node removed, if any; null if none

#### removeAll

    public ArrayNode removeAll()

Method for removing all elements of this array, leaving the array empty.

Specified by:
  `removeAll` in class `ContainerNode<ArrayNode>`
Returns:
  This node (to allow chaining)

#### addArray

    public ArrayNode addArray()

Method that will construct an ArrayNode and add it at the end of this array node.

Returns:
  Newly constructed ArrayNode (NOTE: NOT `this` ArrayNode)

#### addObject

    public ObjectNode addObject()

Method that will construct an ObjectNode and add it at the end of this array node.

Returns:
  Newly constructed ObjectNode (NOTE: NOT `this` ArrayNode)

#### addPOJO

    public ArrayNode addPOJO(Object pojo)

Method that will construct a POJONode and add it at the end of this array node.

Returns:
  This array node, to allow chaining

#### addRawValue

    public ArrayNode addRawValue(RawValue raw)

Returns:
  This array node, to allow chaining
Since:
  2.6

#### addNull

    public ArrayNode addNull()

Method that will add a null value at the end of this array node.

Returns:
  This array node, to allow chaining

#### add

    public ArrayNode add(short v)

Method for adding specified number at the end of this array.

Returns:
  This array node, to allow chaining
Since:
  2.13

#### add

    public ArrayNode add(Short v)

Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

Returns:
  This array node, to allow chaining
Since:
  2.13

#### add

    public ArrayNode add(int v)

Method for adding specified number at the end of this array.

Returns:
  This array node, to allow chaining

#### add

    public ArrayNode add(Integer v)

Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

Returns:
  This array node, to allow chaining

#### add

    public ArrayNode add(long v)

Method for adding specified number at the end of this array.

Returns:
  This array node, to allow chaining

#### add

    public ArrayNode add(Long v)

Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

Returns:
  This array node, to allow chaining

#### add

    public ArrayNode add(float v)

Method for adding specified number at the end of this array.

Returns:
  This array node, to allow chaining

#### add

    public ArrayNode add(Float v)

Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

Returns:
  This array node, to allow chaining

#### add

    public ArrayNode add(double v)

Method for adding specified number at the end of this array.

Returns:
  This array node, to allow chaining

#### add

    public ArrayNode add(Double v)

Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

Returns:
  This array node, to allow chaining

#### add

    public ArrayNode add(BigDecimal v)

Method for adding specified number at the end of this array.

Returns:
  This array node, to allow chaining

#### add

    public ArrayNode add(BigInteger v)

Method for adding specified number at the end of this array.

Returns:
  This array node, to allow chaining
Since:
  2.9

#### add

    public ArrayNode add(String v)

Method for adding specified String value at the end of this array.

Returns:
  This array node, to allow chaining

#### add

    public ArrayNode add(boolean v)

Method for adding specified boolean value at the end of this array.

Returns:
  This array node, to allow chaining

#### add

    public ArrayNode add(Boolean v)

Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

Returns:
  This array node, to allow chaining

#### add

    public ArrayNode add(byte[] v)

Method for adding specified binary value at the end of this array (note: when serializing as JSON, will be output Base64 encoded)

Returns:
  This array node, to allow chaining

#### insertArray

    public ArrayNode insertArray(int index)

Method for creating an array node, inserting it at the specified point in the array, and returning the newly created array (note: NOT 'this' array)

Returns:
  Newly constructed `ArrayNode` (note! NOT `this` ArrayNode)

#### insertObject

    public ObjectNode insertObject(int index)

Method for creating an `ObjectNode`, appending it at the end of this array, and returning the newly created node (note: NOT 'this' array)

Returns:
  Newly constructed `ObjectNode` (note! NOT `this` ArrayNode)

#### insertNull

    public ArrayNode insertNull(int index)

Method that will insert a null value at specified position in this array.

Returns:
  This array node, to allow chaining

#### insertPOJO

    public ArrayNode insertPOJO(int index,
                                Object pojo)

Method that will construct a POJONode and insert it at specified position in this array.

Returns:
  This array node, to allow chaining

#### insertRawValue

    public ArrayNode insertRawValue(int index,
                                    RawValue raw)

Returns:
  This array node, to allow chaining
Since:
  2.13

#### insert

    public ArrayNode insert(int index,
                            short v)

Method that will insert specified numeric value at specified position in this array.

Returns:
  This array node, to allow chaining
Since:
  2.13

#### insert

    public ArrayNode insert(int index,
                            Short value)

Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

Returns:
  This array node, to allow chaining
Since:
  2.13

#### insert

    public ArrayNode insert(int index,
                            int v)

Method that will insert specified numeric value at specified position in this array.

Returns:
  This array node, to allow chaining

#### insert

    public ArrayNode insert(int index,
                            Integer v)

Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

Returns:
  This array node, to allow chaining

#### insert

    public ArrayNode insert(int index,
                            long v)

Method that will insert specified numeric value at specified position in this array.

Returns:
  This array node, to allow chaining

#### insert

    public ArrayNode insert(int index,
                            Long v)

Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

Returns:
  This array node, to allow chaining

#### insert

    public ArrayNode insert(int index,
                            float v)

Method that will insert specified numeric value at specified position in this array.

Returns:
  This array node, to allow chaining

#### insert

    public ArrayNode insert(int index,
                            Float v)

Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

Returns:
  This array node, to allow chaining

#### insert

    public ArrayNode insert(int index,
                            double v)

Method that will insert specified numeric value at specified position in this array.

Returns:
  This array node, to allow chaining

#### insert

    public ArrayNode insert(int index,
                            Double v)

Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

Returns:
  This array node, to allow chaining

#### insert

    public ArrayNode insert(int index,
                            BigDecimal v)

Method that will insert specified numeric value at specified position in this array.

Returns:
  This array node, to allow chaining

#### insert

    public ArrayNode insert(int index,
                            BigInteger v)

Method that will insert specified numeric value at specified position in this array.

Returns:
  This array node, to allow chaining
Since:
  2.9

#### insert

    public ArrayNode insert(int index,
                            String v)

Method that will insert specified String at specified position in this array.

Returns:
  This array node, to allow chaining

#### insert

    public ArrayNode insert(int index,
                            boolean v)

Method that will insert specified String at specified position in this array.

Returns:
  This array node, to allow chaining

#### insert

    public ArrayNode insert(int index,
                            Boolean value)

Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

Returns:
  This array node, to allow chaining

#### insert

    public ArrayNode insert(int index,
                            byte[] v)

Method that will insert specified binary value at specified position in this array (note: when written as JSON, will be Base64 encoded)

Returns:
  This array node, to allow chaining

#### setNull

    public ArrayNode setNull(int index)

Returns:
  This node (to allow chaining)
Since:
  2.13

#### setPOJO

    public ArrayNode setPOJO(int index,
                             Object pojo)

Returns:
  This array node, to allow chaining
Since:
  2.13

#### setRawValue

    public ArrayNode setRawValue(int index,
                                 RawValue raw)

Returns:
  This array node, to allow chaining
Since:
  2.13

#### set

    public ArrayNode set(int index,
                         short v)

Returns:
  This node (to allow chaining)
Since:
  2.13

#### set

    public ArrayNode set(int index,
                         Short v)

Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

Returns:
  This node (to allow chaining)
Since:
  2.13

#### set

    public ArrayNode set(int index,
                         int v)

Returns:
  This node (to allow chaining)
Since:
  2.13

#### set

    public ArrayNode set(int index,
                         Integer v)

Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

Returns:
  This node (to allow chaining)
Since:
  2.13

#### set

    public ArrayNode set(int index,
                         long v)

Returns:
  This node (to allow chaining)
Since:
  2.13

#### set

    public ArrayNode set(int index,
                         Long v)

Returns:
  This node (to allow chaining)
Since:
  2.13

#### set

    public ArrayNode set(int index,
                         float v)

Method for setting value of a field to specified numeric value.

Returns:
  This node (to allow chaining)
Since:
  2.13

#### set

    public ArrayNode set(int index,
                         Float v)

Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

Returns:
  This node (to allow chaining)
Since:
  2.13

#### set

    public ArrayNode set(int index,
                         double v)

Method for setting value of a field to specified numeric value.

Returns:
  This node (to allow chaining)
Since:
  2.13

#### set

    public ArrayNode set(int index,
                         Double v)

Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

Returns:
  This node (to allow chaining)
Since:
  2.13

#### set

    public ArrayNode set(int index,
                         BigDecimal v)

Method for setting value of a field to specified numeric value.

Returns:
  This node (to allow chaining)
Since:
  2.13

#### set

    public ArrayNode set(int index,
                         BigInteger v)

Method for setting value of a field to specified numeric value.

Returns:
  This node (to allow chaining)
Since:
  2.13

#### set

    public ArrayNode set(int index,
                         String v)

Method for setting value of a field to specified String value.

Returns:
  This node (to allow chaining)
Since:
  2.13

#### set

    public ArrayNode set(int index,
                         boolean v)

Method for setting value of a field to specified String value.

Returns:
  This node (to allow chaining)
Since:
  2.13

#### set

    public ArrayNode set(int index,
                         Boolean v)

Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

Returns:
  This node (to allow chaining)
Since:
  2.13

#### set

    public ArrayNode set(int index,
                         byte[] v)

Method for setting value of a field to specified binary value

Returns:
  This node (to allow chaining)
Since:
  2.13

#### equals

    public boolean equals(Object o)

Description copied from class: `JsonNode`
Equality for node objects is defined as full (deep) value equality. This means that it is possible to compare complete JSON trees for equality by comparing equality of root nodes.

Note: marked as abstract to ensure all implementation classes define it properly and not rely on definition from `Object`.

Specified by:
  `equals` in class `JsonNode`

#### _childrenEqual

    protected boolean _childrenEqual(ArrayNode other)

Since:
  2.3

#### hashCode

    public int hashCode()

Specified by:
  `hashCode` in class `BaseJsonNode`

#### _set

    protected ArrayNode _set(int index,
                             JsonNode node)

#### _add

    protected ArrayNode _add(JsonNode node)

#### _insert

    protected ArrayNode _insert(int index,
                                JsonNode node)